package com.gxwebsoft.shop.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.shop.service.GoodsStockInMerchantService;
import com.gxwebsoft.shop.entity.GoodsStockInMerchant;
import com.gxwebsoft.shop.param.GoodsStockInMerchantParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.system.entity.User;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 商户商品库存控制器
 *
 * @author 科技小王子
 * @since 2024-10-05 02:33:23
 */
@Api(tags = "商户商品库存管理")
@RestController
@RequestMapping("/api/shop/goods-stock-in-merchant")
public class GoodsStockInMerchantController extends BaseController {
    @Resource
    private GoodsStockInMerchantService goodsStockInMerchantService;

    @ApiOperation("分页查询商户商品库存")
    @GetMapping("/page")
    public ApiResult<PageResult<GoodsStockInMerchant>> page(GoodsStockInMerchantParam param) {
        // 使用关联查询
        return success(goodsStockInMerchantService.pageRel(param));
    }

    @ApiOperation("查询全部商户商品库存")
    @GetMapping()
    public ApiResult<List<GoodsStockInMerchant>> list(GoodsStockInMerchantParam param) {
        // 使用关联查询
        return success(goodsStockInMerchantService.listRel(param));
    }

    @PreAuthorize("hasAuthority('shop:goodsStockInMerchant:list')")
    @ApiOperation("根据id查询商户商品库存")
    @GetMapping("/{id}")
    public ApiResult<GoodsStockInMerchant> get(@PathVariable("id") Integer id) {
        // 使用关联查询
        return success(goodsStockInMerchantService.getByIdRel(id));
    }

    @ApiOperation("添加商户商品库存")
    @PostMapping()
    public ApiResult<?> save(@RequestBody GoodsStockInMerchant goodsStockInMerchant) {
        // 记录当前登录用户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
            goodsStockInMerchant.setUserId(loginUser.getUserId());
            goodsStockInMerchant.setMerchantId(loginUser.getMerchantId());
            GoodsStockInMerchant check = goodsStockInMerchantService.check(loginUser.getMerchantId(), goodsStockInMerchant.getGoodsId(), goodsStockInMerchant.getSkuId());
            if (check != null) {
                check.setStock(goodsStockInMerchant.getStock());
                goodsStockInMerchantService.updateById(goodsStockInMerchant);
                return success("操作成功");
            }
        }
        if (goodsStockInMerchantService.save(goodsStockInMerchant)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("修改商户商品库存")
    @PutMapping()
    public ApiResult<?> update(@RequestBody GoodsStockInMerchant goodsStockInMerchant) {
        if (goodsStockInMerchantService.updateById(goodsStockInMerchant)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("删除商户商品库存")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (goodsStockInMerchantService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @ApiOperation("批量添加商户商品库存")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<GoodsStockInMerchant> list) {
        if (goodsStockInMerchantService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("批量修改商户商品库存")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<GoodsStockInMerchant> batchParam) {
        if (batchParam.update(goodsStockInMerchantService, "id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("批量删除商户商品库存")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (goodsStockInMerchantService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
